var $j = jQuery.noConflict();
var geocoder;
var map;
var addressField;
var marker;

function googlemap(id,defaultGeoLoc) {
	mapContainerId = "map_canvas_"+id;
	
	// google maps js is loaded async, so we (loop) wait for it
	if (!google || !google.maps) {
		setTimeout('googlemap("'+id+'","'+defaultGeoLoc+'");', 200);
	}
	else {
		$j("#"+id).after("<div id='"+mapContainerId+"' style='width: 500px; height: 300px'>Loading map, please wait...</div>");
		$j("#"+mapContainerId).after("<input type='text' id='search_address_" + id + "' value=''><input type='button' onclick='geoSearch(" + '"' + mapContainerId + '"' + ");' value='検索'>");
		$j("#"+mapContainerId).data("googlemap_tvId",id);
		$j("#"+mapContainerId).data("googlemap_defaultGeoLocation",defaultGeoLoc);
		addressField = document.getElementById('search_address_'+id);
		StartGoogleMaps(mapContainerId);
	}
}

function StartGoogleMaps(mapContainerId) {

	//初期座標
	var tvId = $j("#"+mapContainerId).data("googlemap_tvId");
	var defaultGeoLoc = $j("#"+mapContainerId).data("googlemap_defaultGeoLocation");
	var geoLoc;
	var initOverlay = false;

	if ($j("#"+tvId).val() != '') {		// TV contains a value already?
		geoLoc = $j("#"+tvId).val().split(',');
		initOverlay = true;
	}else {
		geoLoc = (defaultGeoLoc != '')? defaultGeoLoc.split(',') : new Array(52.5,13.5);	// get default from mm_rules, otherwise head to berlin
	}

	//とりあえずMap描画
	var center = new google.maps.LatLng(geoLoc[0], geoLoc[1]);
	var mapOptions = {
		disableDoubleClickZoom:true,
		center: center,
         zoom: 16,
         mapTypeId: google.maps.MapTypeId.ROADMAP
 	  };
	map = new google.maps.Map(document.getElementById(mapContainerId),mapOptions);
	geocoder = new google.maps.Geocoder();

	//マーカー関係
	if (initOverlay) { addMarker(center,tvId); }

	// ダブルクリックで移動
	google.maps.event.addListener(map, 'dblclick', function(point) {
		addMarker(point.latLng,tvId);
	});
}


//マーカー追加（既にあるものは消す）
function addMarker(myLatLng,tvId){
	if(marker){marker.setMap(null);}
	marker = new google.maps.Marker({
		position: myLatLng,
		map: map,
		draggable:true
	});
	map.setCenter(myLatLng);
	$j("#"+tvId).val(myLatLng.lat() + ',' + myLatLng.lng());

	// drag marker listeners
	//google.maps.event.addListener(marker, "dragstart", function() { map.closeInfoWindow();	});
	google.maps.event.addListener(marker, "dragend", function(point) {  $j("#"+tvId).val(point.latLng.lat() + ',' + point.latLng.lng()); });
}

//入力欄からのジオコーディング
function geoSearch(mapContainerId) {
	var tvId = $j("#"+mapContainerId).data("googlemap_tvId");
    geocoder.geocode( {'address': addressField.value}, function(results, status) { 
            if (status == google.maps.GeocoderStatus.OK) { 
                var loc = results[0].geometry.location;
				addMarker(loc,tvId);
            } else {
                alert("Not found: " + status); 
            } 
	});
};

